function controller_result_display(tot_rel_IAE, tot_IAE, time, peak, index, ctrl)

%Finding the crashes in the matrix
crash_idx = tot_rel_IAE(:, index) < 0;

%Calculating the average relative IAE
non_crash_rel_IAE = tot_rel_IAE(~crash_idx, index);
avg_rel_IAE = sum(non_crash_rel_IAE)/length(non_crash_rel_IAE);

%Calculating the average IAE
non_crash_IAE = tot_IAE(~crash_idx, index);
avg_IAE = sum(non_crash_IAE)/length(non_crash_IAE);

%Calculating average time
non_crash_time = time(~crash_idx, index);
avg_time = sum(non_crash_time)/length(non_crash_time);

%Calculating average peak
non_crash_peak = peak(~crash_idx, index);
avg_peak = sum(non_crash_peak)/length(non_crash_peak);

%Calculating STD of relative IAE
std_rel_IAE = std(non_crash_rel_IAE);

%Calculating STD of IAE
std_IAE = std(non_crash_IAE);

%Calculating STD of Time
std_time = std(non_crash_time);

%Printing the results
disp([ctrl, ' average IAE = ', num2str(avg_rel_IAE)]);
disp([ctrl, ' IAE = ', num2str(avg_IAE)]);
disp(['Time average = ', num2str(avg_time)]);
disp(['Peak average = ', num2str(avg_peak)]);
disp(['STD of relative IAE = ', num2str(std_rel_IAE)]);
disp(['STD of IAE = ', num2str(std_IAE)]);
disp(['STD of Time = ', num2str(std_time)]);
if sum(crash_idx) > 0
    disp(['# of crashes for ', ctrl, ': ', num2str(sum(crash_idx))]);
end
disp(' ');