% demo tests for pi(d) tuning methods:
% delta_prc_pi_tun/delta_prc_pid_tun1/MEGATUNER1/MEGATUNER1PLAIN
% on random generated stable state space models.
% Integrator processes will be handled by delta_prc_pi_tun
% 
% c.d.
clear all
close all
clf, clc

%randn('seed',1);
%rand('seed',1);

n=3; % order 
tau=0.1; % time delay
dt=1;   % sample time
s=tf('s');

dsys = drss(n,1,1) % random discrete stable SSM 
dsys.Ts = dt; dsys.D = 0; 

% converting to continous and adding (possible) time delay
csys = d2c(dsys,'zoh');
[b1,a1]=ss2tf(csys.a,csys.b,csys.c,0);
hp=tf(b1,a1)*exp(-tau*s);

while(any(abs(eig(hp))<0.0001)) % i.e. no integrators in this demo
    	dsys = drss(n,1,1);
        dsys.Ts=dt; dsys.D=0;
        csys = d2c(dsys,'zoh');
        [b1,a1]=ss2tf(csys.a,csys.b,csys.c,0);
        hp=tf(b1,a1)*exp(-tau*s);
end

m = 5;
n = 3;
[Y,T]=step(hp);

%Ziegler Nichols
[hc,Kp,Ti]=zn_pi(hp);
[Yr,t]=step(hp*hc/(hc*hp+1));
[Yv,t2]=step(hp/(hc*hp+1));
ZN_error = sum(abs(Yr-1));
ZN_total_error = ZN_error/length(Yr)*t(end)
ZN_total_relative_error = ZN_error/length(Yr)

plotter(T, Y, t, Yr, t2, Yv, m, n, 1)

%PID-tuner
zeta=1;
delta=2.3;
[Kp,Ti,Td]=delta_prc_pid_tun1....
(T,Y,dt,delta,zeta);hc=pidstd(Kp,Ti,Td);rho=delta;
[Yr,t]=step(hp*hc/(hc*hp+1));
[Yv,t2]=step(hp/(hc*hp+1));
% PI_rel_IAE = sum(abs(Yr))/sum(length(Yr))
PID_error = sum(abs(Yr-1));
PID_total_error = PID_error/length(Yr)*t(end)
PID_total_relative_error = PID_error/length(Yr)

plotter(T, Y, t, Yr, t2, Yv, m, n, 4)

%PI-tuner
zeta=1;
delta=2.3;
[Kp,Ti]=delta_prc_pi_tun...
(T,Y,dt,delta,zeta);hc=pidstd(Kp,Ti);rho=delta;
[Yr,t]=step(hp*hc/(hc*hp+1));
[Yv,t2]=step(hp/(hc*hp+1));
PI_rel_IAE = sum(abs(Yr))/sum(length(Yr));
PI_error = sum(abs(Yr-1));
PI_total_error = PI_error/length(Yr)*t(end)
PI_total_relative_error = PI_error/length(Yr)

plotter(T, Y, t, Yr, t2, Yv, m, n, 7)

%Plain Megatuner
rho=2; kp_alt=1;
hc=megatuner1plain(hp,rho,kp_alt);
[Yr,t]=step(hp*hc/(hc*hp+1));
[Yv,t2]=step(hp/(hc*hp+1));
Plain_rel_IAE = sum(abs(Yr))/sum(1*length(Yr))
Plain_error = sum(abs(Yr-1));
Plain_total_error = Plain_error/length(Yr)*t(end)
Plain_total_relative_error = Plain_error/length(Yr)

plotter(T, Y, t, Yr, t2, Yv, m, n, 10)

%Megatuner
[hc,rho]=megatuner1(hp); % heuristic ...
[Yr,t]=step(hp*hc/(hc*hp+1));
[Yv,t2]=step(hp/(hc*hp+1));
Mega_rel_IAE = sum(abs(Yr))/sum(length(Yr))
Mega_error =  sum(abs(Yr-1));
Mega_total_error = Mega_error/length(Yr)*t(end)
Mega_total_relative_error = Mega_error/length(Yr)

plotter(T, Y, t, Yr, t2, Yv, m, n, 13)

