function hp = final_create_random_hp(n, dt, tau)

    s=tf('s');
    pade = (1-0.5*tau*s)/(1+0.5*tau*s);
    skogestad = 1-tau*s;

    dsys = drss(n,1,1); % random discrete stable SSM 
    dsys.Ts = dt; dsys.D = 0; 
    
    % converting to continous and adding (possible) time delay
    csys = d2c(dsys,'zoh');
    [b1,a1]=ss2tf(csys.a,csys.b,csys.c,0);
    % hp=tf(b1,a1);
    hp=tf(b1,a1)*exp(-tau*s);
    % hp=tf(b1,a1)*pade;
    % hp=tf(b1,a1)*skogestad;
    
    while(any(abs(eig(hp))<0.0001)) % i.e. no integrators in this demo
    	    dsys = drss(n,1,1);
            dsys.Ts=dt; dsys.D=0;
            csys = d2c(dsys,'zoh');
            [b1,a1]=ss2tf(csys.a,csys.b,csys.c,0);
            % hp=tf(b1,a1);
            hp=tf(b1,a1)*exp(-tau*s);
            % hp=tf(b1,a1)*pade;
            % hp=tf(b1,a1)*skogestad;
    end
end