function [rel_IAE, IAE, time, peak] = mega_pidtune_controller_executions(hp)
    
    %Megatuner
    [hc,rho]=megatuner1(hp); % heuristic ...
    [Yr,t]=step(hp*hc/(hc*hp+1));
    Mega_peak = max(Yr, [], 'all');
    Mega_time = t(end);
    Mega_error = sum(abs(Yr-1));
    Mega_rel_IAE = Mega_error/(length(Yr));
    if Mega_rel_IAE > 1 || isnan(Mega_rel_IAE)
        Mega_rel_IAE = -1;
    end
    Mega_IAE = Mega_rel_IAE*Mega_time;

    %PID
    hc=pidtune(hp, 'PID');
    [Yr,t]=step(hp*hc/(hc*hp+1));
    PIDtune_peak = max(Yr, [], 'all');
    PIDtune_time = t(end);
    PIDTune_error = sum(abs(Yr-1));
    PIDtune_rel_IAE = PIDTune_error/(length(Yr));
    if PIDtune_rel_IAE > 1
        PIDtune_rel_IAE = -1;
    end
    PIDtune_IAE = PIDtune_rel_IAE*PIDtune_time; 

    %PI
    hc=pidtune(hp, 'PI');
    [Yr,t]=step(hp*hc/(hc*hp+1));
    PItune_peak = max(Yr, [], 'all');
    PItune_time = t(end);
    PITune_error = sum(abs(Yr-1));
    PItune_rel_IAE = PITune_error/(length(Yr));
    if PItune_rel_IAE > 1
        PItune_rel_IAE = -1;
    end
    PItune_IAE = PItune_rel_IAE*PItune_time; 

    rel_IAE = [Mega_rel_IAE, PIDtune_rel_IAE, PItune_rel_IAE];
    IAE = [Mega_IAE, PIDtune_IAE, PItune_IAE];
    time = [Mega_time, PIDtune_time, PItune_time];
    peak = [Mega_peak, PIDtune_peak, PItune_peak];

end